#		By Ewa Marek, Sebastian Student
#    <CustomTools>
#      <Menu>
#       <Item name="Cell TrackID Extension" icon="Python">
#         <Command>PythonXT::XTCellTrackIdExtension()</Command>
#       </Item>
#      </Menu>
#    </CustomTools>
  
import ImarisLib
import numpy as np
import re
from collections import Counter


def XTCellTrackIdExtension(aImarisId):
    
    vImarisLib = ImarisLib.ImarisLib()      
    Id = 0
    vImaris = vImarisLib.GetApplication(aImarisId) 
    
    def find_ids(data, gener, path_id, data2):
        
        cell_ids = []  
        
        if type(gener) == float:
        
            for i in range(len(data[1])):
                        
                    if path_id == data[1][i] and gener == data[2][i]:
                            
                        cell_ids.append(data[0][i])      
            branches = 0            
        
        else:    
        
            for i in range(len(data[1])):
                for j in range(len(gener)):
                        
                    if path_id == data[1][i] and gener[j] == data[2][i]:
                        
                       
                        cell_ids.append(data[0][i])
    
            a = data2[np.where(data2[:, 1] == 'Cell Track Number of Branches')]
            b = a[np.where(a[:, 0] == str(int(path_id))), 2]
            b= b.astype(float) 
            branches = b[0]
    
        return cell_ids, branches
        
        
    def find_edges(aTE, from_find_ids, branches):    
    
        if type(branches) == int or len(branches) == 0:
    
            Edges = [-1]*len(from_find_ids)
            k=0    
            
            for i in from_find_ids:      
                for j in range(len(aTE[0])):
                    if i == aTE[0][j]:
                        Edges[k] = aTE[1][j]
                k = k+1                  
                        
            edges = [from_find_ids, Edges]
            cnt = Counter(from_find_ids)
            cell_div = [ktore for ktore, v in cnt.iteritems() if v > 1] 
            
        else:    
            Edges = [-1]*(len(from_find_ids) + int(branches[0]))
    
            from_fi = [0]*len(Edges)
            k=0    
            
            for i in from_find_ids:
                
                t = 0        
                
                for j in range(len(aTE[0])):
                    if i == aTE[0][j]:
                        Edges[k] = aTE[1][j]
                        from_fi[k] = i            
                        k = k+1    
                        t = 1
                    else:               
                        from_fi[k] = i     
                        
                if t != 1:        
                    k = k+1                
                        
            edges = [from_fi, Edges]   
            cnt = Counter(from_fi)
            cell_div = [ktore for ktore, v in cnt.iteritems() if v > 1] 
        
        return edges, cell_div  
        
        
    def cell_tracks(f_edges, generations):
    
        # znalezieni poczatku sciezek, czyli '-1'
        start = [i for i, j in enumerate(f_edges[1]) if j == -1]
        sciezka = [[] for _ in range(len(start))]
    
        for i in range(len(start)):
        
            w2 = [0]
            w1 = f_edges[0][start[i]]
            sciezka[i].append(w1)    
        
            while len(w2) != 0:
                          
                          w2 = [p for p, r in enumerate(f_edges[1]) if r == w1]
                          
                          if len(w2) != 0:        
    
                                ind = w2[0]
                                w1 = f_edges[0][ind]
                                sciezka[i].append(w1)
    
    
        for i in range(len(start)):
            for j in range(len(sciezka[i])):
                id_z_sciezki = generations[0].index(sciezka[i][j])
                z = 1 + i
                generations[3][id_z_sciezki] = generations[3][id_z_sciezki] + [z]   
    
        data_with_cell_track = generations
        how_many_cells = len(sciezka)
    
        return data_with_cell_track, how_many_cells  
        
 
 
    vScene = vImaris.GetSurpassScene()
    factory = vImaris.GetFactory()
    vSelection = vImaris.GetSurpassSelection()
    
    # do komorek
    vCells = factory.ToCells(vSelection)
    vIds = vCells.GetIds()  # id komorek == aNumOfCell
    aIndicesT = vCells.GetIndicesT()	# indeksy czasu komorek = aNumOfCell
    aTrackEdges = vCells.GetTrackEdges() # < aNumOfCell
    aTrackIds = vCells.GetTrackIds()	#  == aTrackEdges    
        
    ate = np.array(aTrackEdges)
    ate = np.transpose(ate)
    aTE = ate.tolist() # wynik to: aTE[0] - od, aTE[1] - do
    aTI = aTrackIds
    
    r1 = np.column_stack((aTI,aTE[0])) # track_id, od (indeks komorki)
    r2 = np.column_stack((aTI,aTE[1])) # track_id, do (indeks komorki)
    razem = np.concatenate((r1, r2), axis = 0) # TrackID, wszystkie indeksy
    razem_posort = razem[razem[:, 1].argsort()]
    razem_posort = np.transpose(razem_posort)
    razem_posort = razem_posort.tolist()
    razem_posort[0] = map(float, razem_posort[0]) # TrackID
    razem_posort[1] = map(int, razem_posort[1]) # od
    
    aStat = vCells.GetStatistics() 
    mFactorNames = aStat.mFactorNames
    mFactors = aStat.mFactors
    mIds = aStat.mIds
    aNames = aStat.mNames
    aUnits = aStat.mUnits
    mValues = aStat.mValues
    
    data = np.column_stack((mIds, aNames, mValues)) 
    generations = data[np.where(data[:, 1] == 'Cell Generation')] # kom. indeksowane od 0 do 322
    TrId = np.zeros(len(generations[:, 0]))
    generations[:, 1] = TrId[:]
    generations = np.transpose(generations)
    generations = generations.tolist()  # c0 -> cell id, c1 -> cell's TrackID, c2 -> cell's generation
    generations[0] = map(int, generations[0])
    generations[1] = map(float, generations[1])
    generations[2] = map(float, generations[2])
    
    for i in range(len(generations[0])):
        for j in range(len(razem_posort[0])):        
            if generations[0][i] == razem_posort[1][j]:
                generations[1][i] = razem_posort[0][j]
    
    generations.append([[]]*len(generations[0]))
          
    
    uniq_id_path = list(set(generations[1]))
    try:    
        bad_id = uniq_id_path.index(0.0)
        del uniq_id_path[bad_id]
    except:
        pass
    uniq_gener = list(set(generations[2]))    
    
    cell_div = [[]]*len(uniq_id_path)
    hmc = [[]]*len(uniq_id_path)
    
    for i in range(len(uniq_id_path)):
        f_id, branches = find_ids(generations, uniq_gener, uniq_id_path[i], data)
        f_edges, cell_div[i] = find_edges(aTE, f_id, branches)    
        new_data, hmc[i] = cell_tracks(f_edges, generations)
    
    # track_id, indeksy dzielacych sie komorek, ilosc sciezek w danym track_id    
    data_track_id = [uniq_id_path, cell_div, hmc]    
    y_size = np.sum(data_track_id[2])+1
    
    to_table = np.column_stack((mIds, aNames, mValues, mFactors[1], mFactors[3], mFactors[0]))
    to_table = to_table[np.where(to_table[:, 5] == "Cell")]
    to_table = to_table[np.where(to_table[:, 1] == "Cell Volume")]
    
    
    
    to_table = np.transpose(to_table)
    to_table = to_table.tolist() 
    to_table[0] = map(int, to_table[0])
    to_table[2] = map(float, to_table[2])
    try:
        to_table[3] = map(int, to_table[3])
        no_canals = 0
    except ValueError:
        to_table[3] = to_table[3]
        no_canals = 1
    try:
        to_table[4] = map(int, to_table[4])
    except ValueError:
        to_table[4] = to_table[4]
       
    x_size = len(np.unique(to_table[4]))+1
    id_track = []
    id_cell_track = []
    
    for i in range(len(to_table[0])):
        
        ind = generations[0].index(to_table[0][i])
        id_track.append(generations[1][ind])
        id_cell_track.append(generations[3][ind])
            
    to_table.append(id_track)
    to_table.append(id_cell_track)
    
    
    newFactorNames = ['Category', 'Cell TrackID Extension', 'Time']
    cell_track_id_ext = map(str, to_table[7])
    cell_track_id_ext = [ctie.replace('[', '"') for ctie in cell_track_id_ext]
    cell_track_id_ext = [ctie.replace(']', '"') for ctie in cell_track_id_ext]
    newFactors = [["Cell"]*len(to_table[0]), cell_track_id_ext, map(str, to_table[4]) ]
    newNames = ["Cell TrackID Extension"]*len(to_table[0])
    newValues = [0.0]*len(to_table[0])
    newUnits = [' ']*len(to_table[0])
    newIds = to_table[0]
    newIds = map(long, newIds)
    vSelection.AddStatistics(newNames, newValues, newUnits, newFactors, newFactorNames, newIds)     
